#ifndef __SAT_PROTOCOL__
#define __SAT_PROTOCOL__

#pragma once

namespace SATPROTO{
	//////////////////////////////////////////////////////////////////////////
	// Эָ;
	enum ProtocolCMD {
		// ¼ǳ;
		CMD_LOGIN					= 0,
		CMD_LOGOUT,
		// 豸;
		CMD_ADD_DEVICE,
		CMD_DEL_DEVICE,
		CMD_QUERY_DEVICES,
		// ѯ;
		CMD_QUERY_TASK
	};

	//////////////////////////////////////////////////////////////////////////
	// ͨ;
#pragma pack(push)
#pragma pack(1)
	// ͷ;
	typedef struct _DATAHEADER_ {
		// Эʶ;
		byte			protocol;
		// ǰͨŰĳ=header+buf;
		unsigned int	len;
		// ;
		byte			cmd;
	}DataHeader, *pDataHeader;

	// 
	typedef struct _PACKAGE_ {
		DataHeader	header;
		byte		buf[4]; // (ַָ);
	}Package;

	// ڵ¼/ǳ;
	typedef struct __USERINFO__ {
		char		szUserName[MAX_PATH];
		char		szPassword[MAX_PATH];
		char		szActuatorName[MAX_PATH];
	}UserInfo, *pUserInfo;

	// ¼;
	typedef struct __LOGIN_RESP__  {
		// true¼ɹ;
		bool		bStatus;
		// (ʱ);
		char		szMessage[MAX_PATH];
	}LoginResp, *pLoginResp;

	typedef struct __DEVICE__ {
		int 			nType;				// 0=, 1=usb, 2=;
		char		 	szName[MAX_PATH];	// 豸(IP:˿ں);
		int				nStatus;			// 豸״̬0ʾ,1ʾæ;
	}Device, *pDevice;

	// ѯ豸;
	typedef struct __QUERY_DEVICES_RESP__ {
		// 豸;
		int			nSize;
		// ֻܷ30豸;
		Device		ssDevs[30];
	}DeviceResp, *pDeviceResp;

#pragma pack(pop)
}

#endif // __SAT_PROTOCOL__